﻿#pragma once

#include <string>
#include "..\Common\DeviceResources.h"
#include "..\Common\StepTimer.h"
#include "BasicTextRenderer.h"

namespace CharacterFormattingDemo
{
    class CharacterFormattingDemoRenderer
    {
    public:
        CharacterFormattingDemoRenderer(const std::shared_ptr<DX::DeviceResources>& deviceResources);
        void CreateDeviceDependentResources();
        void ReleaseDeviceDependentResources();
        void Update(DX::StepTimer const& timer);
        void Render();

        void SetUseCustomRenderer(bool use);

    private:
        // Cached pointer to device resources.
        std::shared_ptr<DX::DeviceResources> m_deviceResources;

        // Resources related to text rendering.
        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_blackBrush;
        Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;
        Microsoft::WRL::ComPtr<IDWriteTextLayout>       m_textLayout;
        DWRITE_TEXT_METRICS                             m_textMetrics;

        Microsoft::WRL::ComPtr<BasicTextRenderer>       m_textRenderer;
        bool                                            m_useCustomRenderer;
    };
}